<template>
  <div class="type-questions-ddress">
    <select-area-district-city
      :disabled-select="disabledAddress"
      :required="requiredAddress"
      :district-city="districtCity"
      :update-district-city.sync="districtCity"
      :on-select-district="onSelectDistrict"
    />
    <select-area-sub-district
      :disabled-select="disabledAddress"
      :required="requiredAddress"
      :sub-district="subDistrict"
      :update-sub-district.sync="subDistrict"
      :code-district="districtCode"
      :district-code.sync="districtCode"
      :on-select-sub-district="onSelectSubDistrict"
    />
    <select-area-village
      :disabled-select="disabledAddress"
      :required="requiredAddress"
      :village="village"
      :update-village.sync="village"
      :code-sub-district="subDistrictCode"
      :sub-district-code.sync="subDistrictCode"
      :on-select-village="onSelectVillage"
    />
  </div>
</template>

<script>
export default {
  name: 'TypeQuestionsAddress',
  props: {
    disabledAddress: {
      type: Boolean,
      default: false
    },
    requiredAddress: {
      type: Boolean,
      default: false
    },
    answerQuestions: {
      type: Array,
      default: function() {
        return []
      }
    }
  },
  data() {
    return {
      districtCode: '',
      subDistrictCode: '',
      districtCity: '',
      subDistrict: '',
      village: ''
    }
  },
  watch: {
    districtCity: async function(value) {
      if (value.length > 0) {
        this.subDistrict = ''
        this.village = ''
      }
    },
    subDistrict: async function(value) {
      if (value.length > 0) {
        this.village = ''
      }
    }
  },
  methods: {
    async onSelectDistrict(value) {
      this.districtCode = value
      this.subDistrictCode = ''
    },
    async onSelectSubDistrict(value) {
      this.subDistrictCode = value
    },
    async onSelectVillage(value) {
      if (this.answerQuestions.length > 0) {
        this.answerQuestions.splice(0, 1)
        this.answerQuestions.push(value)
      } else {
        this.answerQuestions.push(value)
      }
    }
  }
}
</script>
